// Auto-generated. Do not edit!

// (in-package etsi_its_spatem_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MovementPhaseState = require('./MovementPhaseState.js');
let TimeChangeDetails = require('./TimeChangeDetails.js');
let AdvisorySpeedList = require('./AdvisorySpeedList.js');

//-----------------------------------------------------------

class MovementEvent {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.event_state = null;
      this.timing = null;
      this.timing_is_present = null;
      this.speeds = null;
      this.speeds_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('event_state')) {
        this.event_state = initObj.event_state
      }
      else {
        this.event_state = new MovementPhaseState();
      }
      if (initObj.hasOwnProperty('timing')) {
        this.timing = initObj.timing
      }
      else {
        this.timing = new TimeChangeDetails();
      }
      if (initObj.hasOwnProperty('timing_is_present')) {
        this.timing_is_present = initObj.timing_is_present
      }
      else {
        this.timing_is_present = false;
      }
      if (initObj.hasOwnProperty('speeds')) {
        this.speeds = initObj.speeds
      }
      else {
        this.speeds = new AdvisorySpeedList();
      }
      if (initObj.hasOwnProperty('speeds_is_present')) {
        this.speeds_is_present = initObj.speeds_is_present
      }
      else {
        this.speeds_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MovementEvent
    // Serialize message field [event_state]
    bufferOffset = MovementPhaseState.serialize(obj.event_state, buffer, bufferOffset);
    // Serialize message field [timing]
    bufferOffset = TimeChangeDetails.serialize(obj.timing, buffer, bufferOffset);
    // Serialize message field [timing_is_present]
    bufferOffset = _serializer.bool(obj.timing_is_present, buffer, bufferOffset);
    // Serialize message field [speeds]
    bufferOffset = AdvisorySpeedList.serialize(obj.speeds, buffer, bufferOffset);
    // Serialize message field [speeds_is_present]
    bufferOffset = _serializer.bool(obj.speeds_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MovementEvent
    let len;
    let data = new MovementEvent(null);
    // Deserialize message field [event_state]
    data.event_state = MovementPhaseState.deserialize(buffer, bufferOffset);
    // Deserialize message field [timing]
    data.timing = TimeChangeDetails.deserialize(buffer, bufferOffset);
    // Deserialize message field [timing_is_present]
    data.timing_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [speeds]
    data.speeds = AdvisorySpeedList.deserialize(buffer, bufferOffset);
    // Deserialize message field [speeds_is_present]
    data.speeds_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += AdvisorySpeedList.getMessageSize(object.speeds);
    return length + 19;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_spatem_ts_msgs/MovementEvent';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '24609b2e679fcd824bb9147c2ea23f00';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MovementEvent ::= SEQUENCE {
    #   eventState   MovementPhaseState,
    #   timing       TimeChangeDetails OPTIONAL,
    #   speeds       AdvisorySpeedList OPTIONAL,
    #   regional     SEQUENCE (SIZE(1..4)) OF 
    #                RegionalExtension {{Reg-MovementEvent}} OPTIONAL,
    # ------------------------------------------------------------------------------
    
    MovementPhaseState event_state
    
    TimeChangeDetails timing
    bool timing_is_present
    
    AdvisorySpeedList speeds
    bool speeds_is_present
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/MovementPhaseState
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MovementPhaseState ::= ENUMERATED {
    #   unavailable (0), 
    #   dark (1),   
    #   stop-Then-Proceed (2), 
    #   stop-And-Remain (3),
    #   pre-Movement (4), 
    #   permissive-Movement-Allowed (5), 
    #   protected-Movement-Allowed (6), 
    #   permissive-clearance (7), 
    #   protected-clearance (8),  
    #   caution-Conflicting-Traffic (9)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 DARK = 1
    uint8 STOP_THEN_PROCEED = 2
    uint8 STOP_AND_REMAIN = 3
    uint8 PRE_MOVEMENT = 4
    uint8 PERMISSIVE_MOVEMENT_ALLOWED = 5
    uint8 PROTECTED_MOVEMENT_ALLOWED = 6
    uint8 PERMISSIVE_CLEARANCE = 7
    uint8 PROTECTED_CLEARANCE = 8
    uint8 CAUTION_CONFLICTING_TRAFFIC = 9
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/TimeChangeDetails
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TimeChangeDetails ::= SEQUENCE {
    #   startTime   TimeMark           OPTIONAL,
    #   minEndTime  TimeMark,
    #   maxEndTime  TimeMark           OPTIONAL,
    #   likelyTime  TimeMark           OPTIONAL,
    #   confidence  TimeIntervalConfidence OPTIONAL,
    #   nextTime    TimeMark           OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    
    TimeMark start_time
    bool start_time_is_present
    
    TimeMark min_end_time
    
    TimeMark max_end_time
    bool max_end_time_is_present
    
    TimeMark likely_time
    bool likely_time_is_present
    
    TimeIntervalConfidence confidence
    bool confidence_is_present
    
    TimeMark next_time
    bool next_time_is_present
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/TimeMark
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TimeMark ::= INTEGER (0..36001) 
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 36001
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/TimeIntervalConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TimeIntervalConfidence ::= INTEGER (0..15)   
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 15
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/AdvisorySpeedList
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AdvisorySpeedList ::= SEQUENCE (SIZE(1..16)) OF AdvisorySpeed
    # ------------------------------------------------------------------------------
    
    AdvisorySpeed[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 16
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/AdvisorySpeed
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AdvisorySpeed ::= SEQUENCE {
    #   type        AdvisorySpeedType,
    #   speed       SpeedAdvice OPTIONAL,
    #   confidence  SpeedConfidenceDSRC OPTIONAL,
    #   distance    ZoneLength OPTIONAL,
    #   class       RestrictionClassID OPTIONAL,
    #   regional    SEQUENCE (SIZE(1..4)) OF 
    #               RegionalExtension {{Reg-AdvisorySpeed}} OPTIONAL,
    # ------------------------------------------------------------------------------
    
    AdvisorySpeedType type
    
    SpeedAdvice speed
    bool speed_is_present
    
    SpeedConfidenceDSRC confidence
    bool confidence_is_present
    
    ZoneLength distance
    bool distance_is_present
    
    RestrictionClassID cls
    bool cls_is_present
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/AdvisorySpeedType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AdvisorySpeedType ::= ENUMERATED {
    #   none       (0),
    #   greenwave  (1),
    #   ecoDrive   (2),
    #   transit    (3),
    #   ...  
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 NONE = 0
    uint8 GREENWAVE = 1
    uint8 ECO_DRIVE = 2
    uint8 TRANSIT = 3
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/SpeedAdvice
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SpeedAdvice ::= INTEGER (0..500) 
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 500
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/SpeedConfidenceDSRC
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SpeedConfidenceDSRC ::= ENUMERATED {
    #    unavailable (0), -- Not Equipped or unavailable
    #    prec100ms   (1), -- 100  meters / sec
    #    prec10ms    (2), -- 10   meters / sec
    #    prec5ms     (3), -- 5    meters / sec
    #    prec1ms     (4), -- 1    meters / sec
    #    prec0-1ms   (5), -- 0.1  meters / sec
    #    prec0-05ms  (6), -- 0.05 meters / sec
    #    prec0-01ms  (7)  -- 0.01 meters / sec
    #    }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 PREC100MS = 1
    uint8 PREC10MS = 2
    uint8 PREC5MS = 3
    uint8 PREC1MS = 4
    uint8 PREC0_1MS = 5
    uint8 PREC0_05MS = 6
    uint8 PREC0_01MS = 7
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/ZoneLength
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ZoneLength ::= INTEGER (0..10000)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 10000
    
    
    ================================================================================
    MSG: etsi_its_spatem_ts_msgs/RestrictionClassID
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
    #   asn1/raw/is_ts103301/cdd/ITS-Container.asn
    #   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
    #   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
    #   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
    #   -t
    #   spatem_ts
    #   -o
    #   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RestrictionClassID ::= INTEGER (0..255)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MovementEvent(null);
    if (msg.event_state !== undefined) {
      resolved.event_state = MovementPhaseState.Resolve(msg.event_state)
    }
    else {
      resolved.event_state = new MovementPhaseState()
    }

    if (msg.timing !== undefined) {
      resolved.timing = TimeChangeDetails.Resolve(msg.timing)
    }
    else {
      resolved.timing = new TimeChangeDetails()
    }

    if (msg.timing_is_present !== undefined) {
      resolved.timing_is_present = msg.timing_is_present;
    }
    else {
      resolved.timing_is_present = false
    }

    if (msg.speeds !== undefined) {
      resolved.speeds = AdvisorySpeedList.Resolve(msg.speeds)
    }
    else {
      resolved.speeds = new AdvisorySpeedList()
    }

    if (msg.speeds_is_present !== undefined) {
      resolved.speeds_is_present = msg.speeds_is_present;
    }
    else {
      resolved.speeds_is_present = false
    }

    return resolved;
    }
};

module.exports = MovementEvent;
